
'------------------------------------------------------------------------------
'name                     : UPGREYD ELKA.bas
'copyright                : (c) 2008,   .
'purpose                  :    (15 )
'micro                    : ATMega8-8
'crystal                  :   4
'------------------------------------------------------------------------------

   $regfile = "m8def.dat"                                   '  
   $crystal = 4000000                                       '    4Mhz

   Config Portb = Output                                    '   B  
   Config Pind.2 = Input                                    '  PIND.2  
   Config Pind.3 = Input                                    '  PIND.3  
   Config Portd.0 = Output                                  '  PORTD.0  
   Config Portd.1 = Output                                  '  PORTD.1  
   Config Portd.5 = Output                                  '  PORTD.5  
   Config Portd.6 = Output                                  '  PORTD.6  
   Config Portd.7 = Output                                  '  PORTD.7  
   Config Pinc.5 = Input                                    '  PINC.5  
   Config Portc.0 = Output                                  '  PORTC.0  
   Config Portc.1 = Output                                  '  PORTC.1  
   Config Portc.2 = Output                                  '  PORTC.2  
   Config Portc.3 = Output                                  '  PORTC.3  
   Config Portc.4 = Output                                  '  PORTC.4  

   Dim R1 As Byte                                           ' 
   Dim R2 As Byte
   Dim R3 As Byte
   Dim X As Byte
   Dim X2 As Byte
   Dim Flag1 As Byte
   Dim W1 As Word

   Config Adc = Single , Prescaler = 8 , Reference = Internal       '  
   Stop Adc                                                 ' 

      '   PWM   PB.1  PB.2
   Config Timer1 = Pwm , Pwm = 8 , Prescale = 1 , Compare A Pwm = Clear Down , Compare B Pwm = Clear Down

   Config Int0 = Falling                                    '    
   On Int0 Button                                           '     Button
   Config Int1 = Low Level                                  '    
   On Int1 Foto2                                            '     Foto2
   Enable Interrupts                                        '  
   Enable Int0                                              '    INT0
   Disable Int1                                             '    INT1

   Pwm1a = 255                                              '     OC1A



'-------------------------------------------------------------------------------
'                          HL2
'-------------------------------------------------------------------------------

'     -    
'   -      
'     -     
'   -  (   )

'-------------------------------------------------------------------------------




Do                                                          '  

'-------------------------------------------------------------------------------
'                                
'-------------------------------------------------------------------------------



'1-----------   -----------------------

Ef1:

   For R1 = 1 To 15                                         ' 
   Pulseout Portd , 5 , 25000                               '    portd.5
   Pulseout Portb , 0 , 25000
   Pulseout Portb , 5 , 25000
   Pulseout Portc , 2 , 25000
      If Flag1 = 1 And X2 = 1 Then Goto Audio1              '     Audio1
      If Flag1 = 2 Then Goto Interactiv                     '     Interactiv
   Pulseout Portd , 6 , 25000
   Pulseout Portb , 3 , 25000
   Pulseout Portc , 0 , 25000
   Pulseout Portc , 3 , 25000
      If Flag1 = 1 And X2 = 1 Then Goto Audio1
      If Flag1 = 2 Then Goto Interactiv
   Pulseout Portd , 7 , 25000
   Pulseout Portb , 4 , 25000
   Pulseout Portc , 1 , 25000
   Pulseout Portc , 4 , 25000
      If Flag1 = 1 And X2 = 1 Then Goto Audio1
      If Flag1 = 2 Then Goto Interactiv
   Next                                                     ' 
   X = 0

  '2-------------  ------------------------------------

Ef2:

   Incr X                                                   '  X  
   Gosub Fricolor                                           '   Fricolor

   R2 = 255
   For R1 = 1 To 255
   Decr R2
   Pwm1a = R2
      If Flag1 = 1 And X2 = 1 Then Goto Audio1
      If Flag1 = 2 Then Goto Interactiv
   Waitms 3
   Next
   If X < 3 Then Goto Ef2
   Portd.7 = 0
   Portb.4 = 0
   Portc.0 = 0
   Portc.4 = 0
   Pwm1a = 255


   '3-----   ------------------

Ef3:

   For R1 = 1 To 5
   Portd.5 = 0
   Portd.6 = 1
      If Flag1 = 1 And X2 = 1 Then Goto Audio1
      If Flag1 = 2 Then Goto Interactiv
   Waitms 50
   Portb.0 = 0
   Portb.3 = 1
   Waitms 50
      If Flag1 = 1 And X2 = 1 Then Goto Audio1
      If Flag1 = 2 Then Goto Interactiv
   Portb.5 = 0
   Portc.0 = 1
   Waitms 50
   Portc.2 = 0
   Portc.3 = 1
   Waitms 50
      If Flag1 = 1 And X2 = 1 Then Goto Audio1
      If Flag1 = 2 Then Goto Interactiv
   Portd.6 = 0
   Portd.7 = 1
   Waitms 50
   Portb.3 = 0
   Portb.4 = 1
   Waitms 50
      If Flag1 = 1 And X2 = 1 Then Goto Audio1
      If Flag1 = 2 Then Goto Interactiv
   Portc.0 = 0
   Portc.1 = 1
   Waitms 50
   Portc.3 = 0
   Portc.4 = 1
   Waitms 50
      If Flag1 = 1 And X2 = 1 Then Goto Audio1
      If Flag1 = 2 Then Goto Interactiv
   Portd.7 = 0
   Portd.5 = 1
   Waitms 50
   Portb.4 = 0
   Portb.0 = 1
   Waitms 50
      If Flag1 = 1 And X2 = 1 Then Goto Audio1
      If Flag1 = 2 Then Goto Interactiv
   Portc.1 = 0
   Portb.5 = 1
   Waitms 50
   Portc.4 = 0
   Portc.2 = 1
   Waitms 50
   Next


   '4---  ""     -----

Ef4:

   R3 = 10
   For R1 = 1 To 70
   Gosub Bcolor
      If Flag1 = 1 And X2 = 1 Then Goto Audio1
      If Flag1 = 2 Then Goto Interactiv
   Waitms 10
   Next

   For R1 = 1 To 70
   Gosub Rcolor
      If Flag1 = 1 And X2 = 1 Then Goto Audio1
      If Flag1 = 2 Then Goto Interactiv
   Waitms 10
   Next

   For R1 = 1 To 70
   Gosub Gcolor
      If Flag1 = 1 And X2 = 1 Then Goto Audio1
      If Flag1 = 2 Then Goto Interactiv
   Waitms 10
   Next


  '5---------------   ----------------------------------

Ef5:

   For R1 = 1 To 10
   Portd.5 = 1 : Portb.0 = 1
   Portc.0 = 1 : Portc.3 = 1

   Portb.5 = 0 : Portc.2 = 0
   Portd.7 = 0 : Portb.4 = 0
   Waitms 70
      If Flag1 = 1 And X2 = 1 Then Goto Audio1
      If Flag1 = 2 Then Goto Interactiv
   Portd.5 = 0 : Portb.0 = 0
   Portd.7 = 1 : Portb.4 = 1
   Portc.0 = 1 : Portc.3 = 1
   Waitms 70
      If Flag1 = 1 And X2 = 1 Then Goto Audio1
      If Flag1 = 2 Then Goto Interactiv
   Portc.0 = 0 : Portc.3 = 0
   Portb.5 = 1 : Portc.2 = 1
   Portd.7 = 1 : Portb.4 = 1
   Waitms 70
   Next
   Portd.7 = 0 : Portb.4 = 0


   '6-------------   -------------------------

Ef6:

   R3 = 60

   For R1 = 1 To 10
   Gosub Bcolor
      If Flag1 = 1 And X2 = 1 Then Goto Audio1
      If Flag1 = 2 Then Goto Interactiv
   Waitms 7
   Next

   For R1 = 0 To 10
   Gosub Rcolor
      If Flag1 = 1 And X2 = 1 Then Goto Audio1
      If Flag1 = 2 Then Goto Interactiv
   Waitms 7
   Next

   For R1 = 0 To 10
   Gosub Gcolor
      If Flag1 = 1 And X2 = 1 Then Goto Audio1
      If Flag1 = 2 Then Goto Interactiv
   Waitms 7
   Next


    '7--------------  -----------------------------------

Ef7:

   For R1 = 1 To 3
   R3 = 60

   For R2 = 1 To 60
   Decr R3
     If Flag1 = 1 And X2 = 1 Then Goto Audio1
      If Flag1 = 2 Then Goto Interactiv
   If R1 = 1 Then
   Gosub Rcolor
   End If
     If Flag1 = 1 And X2 = 1 Then Goto Audio1
      If Flag1 = 2 Then Goto Interactiv
   If R1 = 2 Then
   Gosub Gcolor
   End If
     If Flag1 = 1 And X2 = 1 Then Goto Audio1
      If Flag1 = 2 Then Goto Interactiv
   If R1 = 3 Then
   Gosub Bcolor
   End If
   Waitms 10
   Next
   Next


   '8---------  -------------------------

Ef8:

   R3 = 50
   For R1 = 1 To 10
   Gosub Bcolor
      If Flag1 = 1 And X2 = 1 Then Goto Audio1
      If Flag1 = 2 Then Goto Interactiv
   Gosub Rcolor
      If Flag1 = 1 And X2 = 1 Then Goto Audio1
      If Flag1 = 2 Then Goto Interactiv
   Gosub Gcolor
   Next



 '9--------   ,    -------------------

Ef9:

   X = 1
   For R1 = 1 To 3
   Gosub Fricolor
      If Flag1 = 1 And X2 = 1 Then Goto Audio1
      If Flag1 = 2 Then Goto Interactiv
   Incr X

   For R2 = 1 To 100
   Pwm1b = 70
   Waitms 5
   Pwm1b = 0
      If Flag1 = 1 And X2 = 1 Then Goto Audio1
      If Flag1 = 2 Then Goto Interactiv
   Waitms 5
   Next
   Next
   Portd.7 = 0 : Portb.4 = 0 : Portc.1 = 0 : Portc.4 = 0


   '10----------     --------------------

Ef10:

   X = 1
   For R1 = 1 To 3
   Gosub Fricolor
      If Flag1 = 1 And X2 = 1 Then Goto Audio1
      If Flag1 = 2 Then Goto Interactiv
   Incr X

   R3 = 100
   Pwm1b = R3

   For R2 = 1 To 100
   Decr R3
   Pwm1b = R3
      If Flag1 = 1 And X2 = 1 Then Goto Audio1
      If Flag1 = 2 Then Goto Interactiv
   Waitms 7
   Next
   Next
   Portd.7 = 0 : Portb.4 = 0 : Portc.1 = 0 : Portc.4 = 0


  '11----  -   -----------

Ef11:

   R3 = 100
   For R1 = 1 To 10
   Gosub Bcolor
   Pwm1b = 70
   Waitms 10
   Pwm1b = 0
      If Flag1 = 1 And X2 = 1 Then Goto Audio1
      If Flag1 = 2 Then Goto Interactiv
   Gosub Rcolor
   Pwm1b = 70
   Waitms 10
   Pwm1b = 0
      If Flag1 = 1 And X2 = 1 Then Goto Audio1
      If Flag1 = 2 Then Goto Interactiv
   Gosub Gcolor
   Pwm1b = 70
   Waitms 10
   Pwm1b = 0
   Next

   '12----       ------------

Ef12:

   For R1 = 1 To 10
   For R2 = 1 To 250
   Portd.5 = 1
   Portb.0 = 1
   Portb.5 = 1
   Portc.2 = 1
   Delay
   Portd.5 = 0
   Portb.0 = 0
   Portb.5 = 0
   Portc.2 = 0
      If Flag1 = 1 And X2 = 1 Then Goto Audio1
      If Flag1 = 2 Then Goto Interactiv
   Portd.6 = 1
   Portb.3 = 1
   Portc.0 = 1
   Portc.3 = 1
   Waitus 600
   Portd.6 = 0
   Portb.3 = 0
   Portc.0 = 0
   Portc.3 = 0
   Next

   Pwm1b = 70
   Waitms 3
   Pwm1b = 0
   Next


Loop



'-------------------------------------------------------------------------------
'         SB1  
'-------------------------------------------------------------------------------

Button:

   Incr Flag1                                               '  Flag1  

   If Flag1 = 1 Then                                        ' Flag1  1,    ,   
   Start Adc                                                ' 
   Incr X2                                                  '    X2
   End If                                                   ' 
                                                             ' Flag1  2,     
   If Flag1 = 3 Then                                        ' Flag1  3,    
   Stop Adc                                                 ' 
   End If

   If Flag1 > 3 Then                                        ' 
   Disable Int1                                             '   INT1
   Flag1 = 0
   X2 = 0
   End If

   Gifr = 255                                               '      
   Waitms 40                                                ' 40
   Return                                                   '  


'-------------------------------------------------------------------------------
'                  
'-------------------------------------------------------------------------------

Foto1:

   Portd = &B00000000
   Enable Int1                                              '   int1
   Goto Ef1                                                 '    Ef1

Foto2:

   Portb = &B00000000                                       '    B
   Portc = &B0000000                                        '    C
   Portd = &B00000001                                       '    D
   Waitms 15                                                ' 17
   Portd.0 = 0                                              '  D
   Waitms 15                                                ' 17
   Return                                                   '  

'-------------------------------------------------------------------------------
'                   
'-------------------------------------------------------------------------------

Audio1:

   Portb = &B00000000                                       '    B
   Portc = &B0000000                                        '    C
   Portd = &B00000001                                       '    HL2
   W1 = Getadc(5)                                           '   ,    W1
   W1 = W1 * 10                                             '     
   If Flag1 = 2 Then Goto Interactiv                        '     Interactiv
   If W1 > 440 Then                                         '    
   Incr X2                                                  '  X2  
   Portd.0 = 0                                              '  portd.0 .0-  
   Waitms 30                                                ' 30
   End If
   If X2 < 4 Then Goto Audio1                               '     Audio1
   Portd.0 = 0                                              '  D
   Goto Ef1                                                 '    Ef1

'-------------------------------------------------------------------------------
'            interactive
'-------------------------------------------------------------------------------

Interactiv:

   Portd = &B00000010                                       '    HL2
   If Flag1 = 3 Then Goto Foto1                             ' Flag1  3     Foto1
   W1 = Getadc(5)                                           '   ,    W1
   W1 = W1 * 15                                             '     
   If W1 > 130 Then Goto Color                              '     Color
   Goto Interactiv                                          '    Interactiv

Color:
   If Flag1 = 3 Then Goto Foto1                             ' Flag1  3     Foto1
   R3 = 25                                                  '  R3  25
   Gosub Bcolor                                             '   Bcolor
   Gosub Rcolor                                             '   Rcolor
   Gosub Gcolor                                             '   Gcolor
   Goto Interactiv                                          '    Interactiv

'-------------------------------------------------------------------------------
'      : ,,
'-------------------------------------------------------------------------------

Bcolor:                                                     '

   Portd.5 = 1
   Portb = &B00100001
   Portc.2 = 1
   Waitms R3
   Portd.5 = 0
   Portb = &B00000000
   Portc.2 = 0
   Return

Rcolor:                                                     '

   Portd.6 = 1
   Portb.3 = 1
   Portc = &B0001001
   Waitms R3
   Portd.6 = 0
   Portb.3 = 0
   Portc = &B0000000
   Return

Gcolor:                                                     '

   Portd.7 = 1
   Portb.4 = 1
   Portc = &B0010010
   Waitms R3
   Portd = &B00000000
   Portb = &B00000000
   Portc = &B0000000
   Return

Fricolor:                                                   ' 

   If X = 1 Then
   Portd.5 = 1
   Portb = &B00100001
   Portc.2 = 1
   End If
   If X = 2 Then
   Portd.5 = 0
   Portb = &B00001000
   Portc = &B0001001
   Portd.6 = 1
   End If
   If X = 3 Then
   Portd.6 = 0
   Portb = &B00010000
   Portc = &B0010010
   Portd.7 = 1
   End If
   Return